#ifndef COLOR_X01R05G05B05I_h
#define COLOR_X01R05G05B05I_h

/*!
 	@file
 	@brief	１ピクセルをあらわすクラス郡
\n			XRGB1555 フォーマット Ver.
*/

#include"../../Setup/CompileMode.h"
#include"../../Auxiliary/Macro.h"

#include"PixelConvertFunction.h"

namespace Maid
{
	/*!
	 	@class	COLOR_X01R05G05B05I COLOR_X01R05G05B05I.h
	 	@brief	アルファなし１６ビットピクセル
	 */
	class COLOR_X01R05G05B05I
	{
	public:
		COLOR_X01R05G05B05I(){}	//!<	コンストラクタ
		COLOR_X01R05G05B05I( unt08 a, unt08 r, unt08 g, unt08 b ){ SetRGB( r, g, b ); }	//!<	コンストラクタ
		template <class COLOR>
		COLOR_X01R05G05B05I( const COLOR& Col ){  SetRGB( Col.GetR(), Col.GetG(), Col.GetB() );  }	//!<	コンストラクタ


		unt08 GetA() const	{ return 0xFF;		}	//!<	アルファ成分の取得
		unt08 GetR() const	{ return PIXELCONVERT05_08((m_RGB&0x7C00)>>10);	}	//!<	赤成分の取得
		unt08 GetG() const	{ return PIXELCONVERT05_08((m_RGB&0x03E0)>> 5);	}	//!<	緑成分の取得
		unt08 GetB() const	{ return PIXELCONVERT05_08((m_RGB&0x001F)<< 3);	}	//!<	青成分の取得

		operator unt16() const { return m_RGB; }	//!<	一括変換

		void SetA( unt08 a )	{ }															//!<	アルファ成分の設定
		void SetR( unt08 r )	{ m_RGB = (m_RGB&~0x7C00)|(PIXELCONVERT08_05(r)<<10);	}	//!<	赤成分の設定
		void SetG( unt08 g )	{ m_RGB = (m_RGB&~0x03E0)|(PIXELCONVERT08_05(g)<< 5);	}	//!<	緑成分の設定
		void SetB( unt08 b )	{ m_RGB = (m_RGB&~0x001F)|(PIXELCONVERT08_05(b)<< 0);	}	//!<	青成分の設定

		void SetRGB( unt08 r, unt08 g, unt08 b )	//!<	いっきに設定
		{
			SetR( r );
			SetG( g );
			SetB( b );
		}

		//!	違うピクセルフォーマットとのコピー
		template <class PIXEL>
		COLOR_X01R05G05B05I& operator = (const PIXEL &src)
		{
			SetRGB(src.GetR(),src.GetG(),src.GetB());
			return *this;
		}

		//!	同じピクセルフォーマットとのコピー
		COLOR_X01R05G05B05I& operator = (const COLOR_X01R05G05B05I& src)
		{
			m_RGB = src.m_RGB;
			return *this;
		}

	private:
		unt16 m_RGB;
	};


}

#endif
